

function [ris maxmod]= laststep(M,gen,popSize,CrossoverFraction,mutationRate,vettorizzato)


numberOfVariables = size(M,2);       %number of variables is the row-column number 

           %per ogni nodo si calcola l'elenco dei vicini
  for k=1:numberOfVariables  
    if ((sum(M(k,:))==0)) 
        Neighbor{k}=0;
        %k
        %Neighbor{k}
    else   %per ogni nodo si calcola l'elenco dei vicini
  Neighbor{k} = find(M(k,:));
    end
  end

for k=1:numberOfVariables            %per ogni nodo si calcola il  vicino migliore
    if (Neighbor{k}==0) 
        bestNN(k)=0;
    else
      bestNN(k) = bestNeighbor(k,Neighbor);
    end
end
   
type create_population.m;


type crossover_cluster.m;


type mutate_cluster.m;

%type cluster_fitness.m
type cluster_fitnessMod.m;  %ottimizza la modularit?


%FitnessFcn = @(x)cluster_fitness(x,M,alfa);
FitnessFcn = @(x)cluster_fitnessMod(x,M);

 
 
options = gaoptimset('PopulationType', 'custom','PopInitRange', ...
    [1;numberOfVariables]);

Elitecount=(options.PopulationSize*10)/100;
%mutationRate=0.6;
%CrossoverFraction=0.8;
options = gaoptimset(options,'CreationFcn',{@create_population,bestNN,Neighbor}, ...
    'CrossoverFcn',{@crossover_cluster},...
    'MutationFcn',{@mutate_cluster, mutationRate,Neighbor}, ...
    'PlotFcn', {@plotfun,@gaplotscores,@gaplotscores,@gaplotrange}, ...
    'SelectionFcn',@selectionroulette, ...
    'Generations',gen,'PopulationSize',popSize, ...
    'StallTimeLimit',Inf, ...
    'StallGenLimit',20,'Vectorized',vettorizzato);


[x,fval,reason,output,population,scores] = ga(FitnessFcn,numberOfVariables,options);
hold on


%disp('siamo in lastsetp');
fval;
[maxmod i] = min(fval(:,1));
maxmod=-maxmod;

ris=decodenew(x(i,:));

 
function pos=bestNeighbor(node,Neighbor) %trova per ogni nodo il vicino con cui condivide il massimo numero di vicini
maxshared=-1;
pos=0;
%Neighbor{node}
for j=1:size(Neighbor{node},2)
    if (j ~= node)
       vicino=Neighbor{node}(j);
       shared=size(intersect(Neighbor{node},Neighbor{vicino}),2);
       if(shared > maxshared)
        maxshared=shared;
        pos=j;
       end
    end
end
end
end
